# Copyright 2020 The TensorFlow Probability Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
"""TensorFlow Probability experimental sequential estimation package."""

from tensorflow_probability.substrates.numpy.experimental.sequential.ensemble_adjustment_kalman_filter import ensemble_adjustment_kalman_filter_update
from tensorflow_probability.substrates.numpy.experimental.sequential.ensemble_kalman_filter import ensemble_kalman_filter_log_marginal_likelihood
from tensorflow_probability.substrates.numpy.experimental.sequential.ensemble_kalman_filter import ensemble_kalman_filter_predict
from tensorflow_probability.substrates.numpy.experimental.sequential.ensemble_kalman_filter import ensemble_kalman_filter_update
from tensorflow_probability.substrates.numpy.experimental.sequential.ensemble_kalman_filter import EnsembleKalmanFilterState
from tensorflow_probability.substrates.numpy.experimental.sequential.ensemble_kalman_filter import inflate_by_scaled_identity_fn
from tensorflow_probability.substrates.numpy.experimental.sequential.extended_kalman_filter import extended_kalman_filter
from tensorflow_probability.substrates.numpy.experimental.sequential.iterated_filter import geometric_cooling_schedule
from tensorflow_probability.substrates.numpy.experimental.sequential.iterated_filter import IteratedFilter
from tensorflow_probability.python.internal import all_util


_allowed_symbols = [
    'IteratedFilter',
    'extended_kalman_filter',
    'EnsembleKalmanFilterState',
    'ensemble_kalman_filter_predict',
    'ensemble_kalman_filter_update',
    'ensemble_kalman_filter_log_marginal_likelihood',
    'ensemble_adjustment_kalman_filter_update',
    'geometric_cooling_schedule',
    'inflate_by_scaled_identity_fn',
]

all_util.remove_undocumented(__name__, _allowed_symbols)


# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
# This file is auto-generated by substrates/meta/rewrite.py
# It will be surfaced by the build system as a symlink at:
#   `tensorflow_probability/substrates/numpy/experimental/sequential/__init__.py`
# For more info, see substrate_runfiles_symlinks in build_defs.bzl
# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
